--[[local filesel=UI.FileSelector.new()
filesel:setDimensions(400,300)
filesel:setPosition(50,50)
stage:addChild(filesel)
]]

local demo=UI.Builder({
		class="UI.Dialog",  
		layoutModel=UI.Layout.Vertical,layout={fill=1},
		children={
			{ class="UI.Label", Text="Gideros WidgetKit demo" },
			{ class="UI.Splitpane", Vertical=false, layout={weighty=1,weightx=1,insetBottom=2},				
				--Directory Tree
				Tabs={.1,.3,.8},
				Ratio=.3,
				OpenDirection=nil,
				First={ class=UI.Viewport, layout={weightx=1,fill=1},
						Content={ class="UI.Tree", name="dirTree", layout={anchor=Sprite.LAYOUT_ANCHOR_NORTHWEST}, 
						selection=UI.Selection.SINGLE,
						dataMapper=function(item) 
							if type(item)=="string" then 
								return item
							else
								return item.name,item.sub
							end
						end, data={{ name="Root", sub={
							"A",
							"B",
							{ name="C", sub={
								"1",
								{ name="2", sub={"a","b"}},
								"3"}},
							"D"
						}}}},
					},
					--Right side
				Second={ class="UI.Panel", layoutModel=UI.Layout.Vertical, layout={weightx=1, fill=1},
						children={
							{ class=UI.BreadCrumbs,layout={ fill=Sprite.LAYOUT_FILL_HORIZONTAL }, name="bcBread"  },
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class=UI.Checkbox,Label="This is a checkbox",  },
									{ class=UI.Checkbox,Label="This is a tristate checkbox", Tristate=true },
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class=UI.Radio,Label="Radio 1", Group="RadioA" },
									{ class=UI.Radio,Label="Radio 2", Group="RadioA" },
									{ class=UI.Radio,Label="Radio 3", Group="RadioA" },
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Editable Text:" },
									{ class="UI.TextField", Text="Pre-filled", layout={width="10em"},TipText="Enter something" },
									{ class="UI.Label", Text="Editable Password:" },
									{ class="UI.PasswordField", Password="•", layout={width="10em"}, TipText="A password" },
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Disabled textfield:" },
									{ class="UI.TextField", Flags={ disabled=true }, layout={width="10em"}, TipText="disabled text" },
									{ class="UI.Label", Text="Readonly textfield:" },
									{ class="UI.TextField", Flags={ readonly=true }, layout={width="10em"}, TipText="disabled text" },
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Horizontal slider:" },
									{ class="UI.Slider", layout={minWidth=200,prefWidth=200,insetTop="1em"},
											Formatter=function(w,p) w:setText(("%d%%"):format(p//0.01)) end,
											--Path="m959 373c-48.5-115.5-97.5-231-153-231-111 0-195 462-306 462s-195-462-306-462c-55.5 0-104.5 115.5-153 231"
											--Path="M0,0L1,1L2,0"
									},
									{ class="UI.Label", Text="Double slider:" },
									{ class="UI.Slider", layout={minWidth=300,prefWidth=300,insetTop="1em"},
											Resolution=1/12,
											Formatter=function(w,p) w:setText(("%d h"):format((p*24+.5)//1)) end,
											Dual=true,
											--Path="m959 373c-48.5-115.5-97.5-231-153-231-111 0-195 462-306 462s-195-462-306-462c-55.5 0-104.5 115.5-153 231"
											--Path="M0,0L1,1L2,0"
									},
									{ class="UI.Label", Text="Apart slider:" },
									{ class="UI.Slider", layout={minWidth=300,prefWidth=300,insetTop="1em"},
											Resolution=1/24,
											Formatter=function(w,p) w:setText(("%dh"):format((p*24+.5)//1)) end,
											Dual=true,
											HandleOffset=1,
									},
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Arc slider:" },
									{ class="UI.ArcSlider", layout={width="10em",height="5em"},
											StartAngle=30,EndAngle=90,Flags={ disabled=true }
									},
									--[[
									{ class="UI.ArcSlider", layout={width="10em",height="10em",insetTop="1em"},
											StartAngle=0,EndAngle=270,
											Resolution=1/12,
											Formatter=function(w,p) w:setText(("%d h"):format((p*24+.5)//1)) end,
											Dual=true,
											--Path="m959 373c-48.5-115.5-97.5-231-153-231-111 0-195 462-306 462s-195-462-306-462c-55.5 0-104.5 115.5-153 231"
											--Path="M0,0L1,1L2,0"
									},]]
									{ class="UI.Label", Text="Circular progress:" },
									{ class="UI.CircularProgress", layout={width="10em"},
										Progress=0.3,
									},
									{ class="UI.CircularProgress", layout={width="10em"},
										Progress=0.6,
										Indeterminate=true,
									},
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Progress bar:" },
									{ class="UI.ProgressBar", layout={width="10em"},
										Progress=0.3, TextFormat="%d%%",
									},
									{ class="UI.ProgressBar", Flags={ disabled=true }, layout={width="10em"},
										Progress=0.5, TextFormat="Done: %d%%",
									},
									{ class="UI.ProgressBar", layout={width="10em"},
										Progress=0.5, TextFormat="Done: %d%%",
										Indeterminate=true,
									},
									{ class="UI.ProgressBeads", layout={width="10em"},
										TextFormat="Done: %d%%",
										Indeterminate=5,
									},
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Spinner:" },
									{ class="UI.Spinner", layout={width="10em"},
										Range={ Min=1, Max=4, Step=1 },
									},
									{ class="UI.Spinner", Flags={ disabled=true }, layout={width="10em"},
										Range={"A","B","C" },
									},
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Toolbox:" },
									{ class="UI.Toolbox",
										data={ "A","B","C"},
										dataMapper=function(d)
											return d
										end,
										Header={ class="UI.Image", Image="|R|ui/icons/kbd_hide.png", layout={ width="2is", height="2is" } },
										Direction=true, --Horizontal
									},
								},
							},
							{ class="UI.Panel", layoutModel=UI.Layout.Horizontal, layout={ fill=Sprite.LAYOUT_FILL_NONE,anchor=Sprite.LAYOUT_ANCHOR_WEST},
								children={
									{ class="UI.Label", Text="Calendar:" },
									{ class="UI.DatePicker",
										AllowNil=true,
									},
									{ class="UI.Label", Text="TimePicker:" },
									{ class="UI.TimePicker",
										AllowNil=true,
									},
								},
							},
							{ class="UI.Label", Text="Multiline Text:" },
							{ class=UI.Viewport,  layout={weighty=2,fill=1},
								Content={ class="UI.TextField", layout={fill=1}, TextLayout={ flags=FontBase.TLF_TOP|FontBase.TLF_REF_TOP, multiline=true}},
							},
							{ class="UI.Label", Text="Table:" },
							{ class=UI.Viewport,  layout={weighty=1,fill=1}, Scrollbar=UI.Viewport.SCROLLBAR.POP_OVER,
								Content={ class="UI.Table", name="fileTable", layout={fill=Sprite.LAYOUT_FILL_HORIZONTAL,anchor=Sprite.LAYOUT_ANCHOR_NORTHWEST},
									selection=UI.Selection.MULTIPLE,
									AllowColumnReorder=true,
									AllowColumnResize=true,
									CellSpacingX=2,
									Columns={
										{ name="First name",field="first",weight=2},
										{ name="Last name",field="last",weight=2},
										{ name="Song",field="song",weight=3}},
									data={}
								},
							},
						},
					},				
			},
			{ class="UI.Panel", layoutModel=UI.Layout.Horizontal,
				children={
					{ class=UI.Panel,layout={weightx=1} }, --Filler
					{ class=UI.Button, name="btHelp", Text="Help",layout={insets="1s"}, behavior=UI.Behavior.LongClick, behaviorParams={} },
					{ class=UI.Button, name="btInfo", Text="About",layout={insets="1s"} },
				},
			}
		}
	})
	
local screen=UI.Screen.new()
screen:ui(demo)

demo.bcBread:setData({ "ROOT", "Dossier 1","D2","D3","Test 4","Et un grand 5", "P6", "Et finalement encore un très grand 7","Mais c'est pas sûr que ça suffise 8","Alors un 9 ?" })
function demo:onWidgetAction(w)
	if w==self.btInfo then
		local dialog=UI.Dialog.confirm("Do you agree","Yes!","No :(")
		local scw=screen:getWidth()
		dialog:setAnchorPosition(scw,0)
		UI.ModalScreen.showDialog(screen,dialog,function(res,dialog,cleanup)
			UI.Animation:animate(dialog,"pop",UI.Animation.AnchorMove,3000,{x=-scw,onStop=cleanup})
			return true
		end,"colShadow",100)
		UI.Animation:animate(dialog,"pop",UI.Animation.AnchorMove,1000,{ easing={type="bounce",way="in"}})
	end
end

demo.dirTree:setAllowDnd(true,true)

UI.Style:setDefault(UI.Theme.PointCore_Base)
screen:updateStyle()

UI.Keyboard.NATIVE=false
UI.Keyboard.PHYSICAL=false
UI.Keyboard.VIRTUAL=true

local rows = {
	{ first="Paul", last="McCartney", song="Maybe I'm Amazed"},
	{ first="Ringo", last="Starr", song="Photograph"},
	{ first="George", last="Harrison", song="My Sweet Lord"},
	{ first="John", last="Lennon", song="Imagine"},
	{ first="Paul", last="McCartney", song="Maybe I'm Amazed"},
	{ first="George", last="Harrison", song="My Sweet Lord"},
	{ first="Ringo", last="Starr", song="Photograph"},
	{ first="John", last="Lennon", song="Imagine"},
	{ first="Paul", last="McCartney", song="Maybe I'm Amazed"},
	{ first="George", last="Harrison", song="My Sweet Lord"},
	{ first="Ringo", last="Starr", song="Photograph"},
	{ first="John", last="Lennon", song="Imagine"},
	{ first="Paul", last="McCartney", song="Maybe I'm Amazed"},
	{ first="George", last="Harrison", song="My Sweet Lord"},
	{ first="Ringo", last="Starr", song="Photograph"},
	{ first="John", last="Lennon", song="Imagine"},
	{ first="Paul", last="McCartney", song="Maybe I'm Amazed"},
	{ first="George", last="Harrison", song="My Sweet Lord"},
	{ first="Ringo", last="Starr", song="Photograph"},
}

--print("SET 3 ROWS : Paul,Ringo et George")
demo.fileTable:setData(table.clone(rows))
local index = 1
--print("ADD 1 ROW John at index",index)
table.insert(rows,index,{ first="John", last="Lennon", song="Imagine"})
demo.fileTable:setData(table.clone(rows))

